﻿namespace ConsoleAppTrafficLight
{
    internal class CombinedTrafficLight
    {
        public void DisableAutoTraffic()
        {
            SetAutoRed();
        }

        public void DisablePedestrianTraffic()
        {
            SetPedestrianRed();
        }

        public void EnableAutoTraffic()
        {
            SetAutoGreen();
            SetPedestrianRed();
        }

        public void EnableLightSwitch()
        {
            SetAutoYellow();
        }

        public void EnablePedestrianTraffic()
        {
            SetAutoRed();
            SetPedestrianGreen();
        }

        private void SetAutoGreen()
        {
            if (AutoGreen != true)
            {
                AutoGreen = true;

                PedestrianGreen = false;
                AutoRed = false;
                AutoYellow = false;
            }
        }

        private void SetAutoRed()
        {
            if (AutoRed != true)
            {
                AutoRed = true;

                AutoYellow = false;
                AutoGreen = false;
            }
        }

        private void SetAutoYellow()
        {
            if (AutoYellow != true)
            {
                AutoYellow = true;

                PedestrianGreen = false;
                AutoRed = false;
                AutoGreen = false;
            }
        }

        private void SetPedestrianGreen()
        {
            if (PedestrianGreen != true)
            {
                PedestrianGreen = true;

                AutoGreen = false;
                PedestrianRed = false;
            }
        }

        private void SetPedestrianRed()
        {
            if (PedestrianRed != true)
            {
                PedestrianRed = true;

                PedestrianGreen = false;
            }
        }

        public bool AutoGreen { get; private set; }

        public bool AutoRed { get; private set; }

        public bool AutoYellow { get; private set; }

        public bool PedestrianGreen { get; private set; }

        public bool PedestrianRed { get; private set; }
    }
}
